<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon"></app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <div *ngIf="!loading">

      <kendo-grid [data]="dataGrid" [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true"
                  [scrollable]="'virtual'" [filter]="filter" [filterable]="false"
                  (filterChange)="filterChange($event)"
                  [sort]="sort"
                  [sortable]="true" [rowHeight]="40" (sortChange)="sortChange($event)"
                  [groupable]="{ showFooter: true }"
                  [group]="groups" (groupChange)="groupChange($event)" (dataStateChange)="dataStateChange($event)"
                  style="height: 87vh">
        <ng-template kendoGridToolbarTemplate>
          <div class="row">
            <div class="col d-flex justify-content-end">
              <button type="button" (click)="getReporte()" class="btn btn-light"
                      [disabled]="!formSearch.valid || loading">
                <i class="fas mr-2 text-primary"
                   [ngClass]="{'fa-spinner fa-spin': loading, 'fa-search': !loading }"></i>Buscar
              </button>
              <button type="button" (click)="exportPDF()" class="btn btn-light ml-1"
                      [disabled]="!dataGrid.data">
                <i class="fa fa-file-pdf mr-2 text-danger"></i>PDF
              </button>
              <button type="button" (click)="exportExcel()" class="btn btn-light ml-1"
                      [disabled]="!dataGrid.data">
                <i class="fa fa-file-excel mr-2 text-success"></i>Excel
              </button>
              <!-- <button type="button" (click)="viewDetail()" class="btn btn-light ml-1" [disabled]="!dataGrid.data">
                    <i class="fa fa-external-link mr-2"></i>Detalle
                  </button> -->
              <!-- <button type="button" (click)="generateChart()" class="btn btn-light ml-1" [disabled]="!dataGrid.data" *ngIf="!flagChart" >
                    <i class="fa fa-dashboard mr-2"></i>Gráfica
                  </button>
                  <button type="button" (click)="flagChart = false" class="btn btn-light ml-1" [disabled]="!dataGrid.data" *ngIf="flagChart">
                      <i class="fa fa-table mr-2"></i>Grid
                  </button> -->
              <button type="button" (click)="flagForm = !flagForm" class="btn btn-outline-light ml-1">
                <i class="fa" [ngClass]="{ 'fa-angle-up': flagForm, 'fa-angle-down': !flagForm }"></i>
              </button>
            </div>
          </div>
          <form [formGroup]="formSearch">
            <div class="row animated fadeIn d-flex justify-content-start" *ngIf="flagForm">
              <div class="row-fluid col-7 col-sm-4 col-md-3 col-lg-3 col-xl-2">
                <div>
                  <kendo-daterange>
                    <label>Fecha Desde</label>
                    <kendo-dateinput kendoDateRangeStartInput formControlName="fechaIni"
                                     [(value)]="formSearch.value.fechaIni" class="w-100">
                    </kendo-dateinput>
                    <label class="mt-1">Fecha Hasta</label>
                    <kendo-dateinput kendoDateRangeEndInput formControlName="fechaFin"
                                     [(value)]="formSearch.value.fechaFin"
                                     class="w-100">
                    </kendo-dateinput>
                  </kendo-daterange>
                </div>
              </div>
              <div class="row-fluid col-12 col-sm-5 col-md-5 col-lg-5 col-xl-4">
                <div>
                  <label for="punto">Punto</label>
                  <kendo-dropdownlist [data]="dsPuntos" name="punto" class="w-100" formControlName="punto"
                                      [(ngModel)]="formSearch.value.punto" [textField]="'pdesc'"
                                      [valueField]="'Punto'"
                                      [valuePrimitive]="true">
                  </kendo-dropdownlist>
                </div>
                <div class="row">
                  <div class="col-6">
                    <label for="clase">Clase</label>
                    <kendo-dropdownlist [data]="dsClases" name="clase" class="w-100"
                                        formControlName="clase"
                                        [(ngModel)]="formSearch.value.clase" [textField]="'cdesc'"
                                        [valueField]="'clase'"
                                        [valuePrimitive]="true">
                    </kendo-dropdownlist>
                  </div>
                  <div class="col-6">
                    <label for="tipo">Tipo</label>
                    <kendo-dropdownlist [data]="dsTiposPlatillos" name="tipo" class="w-100"
                                        formControlName="tipo"
                                        [(ngModel)]="formSearch.value.tipo" [textField]="'tdesc'"
                                        [valueField]="'tipo'"
                                        [valuePrimitive]="true">
                    </kendo-dropdownlist>
                  </div>
                </div>
              </div>
              <div class="row-fluid col-12 col-sm-5 col-md-5 col-lg-5 col-xl-4">
                <label for="platillo">Platillo</label>
                <kendo-dropdownlist [data]="dsPlatillos" name="platillo" class="w-100"
                                    formControlName="platillo"
                                    [(ngModel)]="formSearch.value.platillo" [textField]="'pdesc'"
                                    [valueField]="'platillo'"
                                    [valuePrimitive]="true">
                </kendo-dropdownlist>
                <div class="row">
                  <div class="col-12">
                    <label for="clasificacion">Clasificacion</label>
                    <kendo-multiselect [data]="dsClasificaciones" name="clasificacion" class="w-100"
                                       formControlName="clasificacion"
                                       placeholder="Seleccionar clasificacion"
                                       [(ngModel)]="formSearch.value.clasificacion"
                                       [textField]="'field'"
                                       [valueField]="'value'">
                    </kendo-multiselect>
                  </div>
                </div>
              </div>
              <div class="row-fluid my-4 col-2 form-group">
                <div class="custom-control custom-checkbox">
                  <input type="checkbox" class="custom-control-input" formControlName="detallado"
                         [(ngModel)]="formSearch.value.detallado" name="detallado" id="detallado">
                  <label class="custom-control-label" for="detallado">Detallado</label>
                </div>
                <div class="custom-control custom-checkbox">
                  <input type="checkbox" class="custom-control-input" formControlName="cancelado"
                         [(ngModel)]="formSearch.value.cancelado" name="cancelado" id="cancelado">
                  <label class="custom-control-label" for="cancelado">Incluir Cxld's</label>
                </div>
                <div class="custom-control custom-checkbox">
                  <input type="checkbox" class="custom-control-input" formControlName="infohues"
                         [(ngModel)]="formSearch.value.infohues" name="infohues" id="infohues">
                  <label class="custom-control-label" for="infohues">Informacion Huesped</label>
                </div>
              </div>
            </div>
          </form>
          <div class="animated fadeIn d-flex justify-content-center" *ngIf="flagChart">
            <app-chart-propinas [dataGrid]="dataGrid"></app-chart-propinas>
          </div>
        </ng-template>
        <ng-container *ngIf="!flagChart">
          <kendo-grid-column field="tpunt" title="Punto" [filterable]="true" width="90" class="text-right">
          </kendo-grid-column>
          <kendo-grid-column field="ttipo" title="#Tipo" [filterable]="false" width="90" class="text-right">
          </kendo-grid-column>
          <kendo-grid-column field="tplat" title="#Platillo" [filterable]="true" width="100" class="text-right">
          </kendo-grid-column>
          <kendo-grid-column field="tdesc" title="Desc." [filterable]="true"></kendo-grid-column>
          <kendo-grid-column field="tporc" title="Porción" [filterable]="true" width="100" media="md"
                             class="text-right">
          </kendo-grid-column>
          <kendo-grid-column field="tmont" title="Ingresos" [filterable]="true" width="100" media="md"
                             class="text-right">
            <ng-template kendoGridCellTemplate
                         let-dataItem>{{ dataItem.tmont | kendoNumber:'##.00' }}</ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="tagen" title="Agencia" [filterable]="false" width="120"></kendo-grid-column>
          <kendo-grid-column field="tseg" title="Segmento" [filterable]="true" width="120"
                             media="md"></kendo-grid-column>
        </ng-container>
      </kendo-grid>

    </div>
<app-loading *ngIf="loading"></app-loading>

    <kendo-window title="Detalle Reporte de Platillos" class="animated fadeIn w-100" *ngIf="flagViewDetail"
                  (close)="close()">
      <kendo-grid [data]="dsResumen" [selectable]="true" [navigable]="true" [reorderable]="true"
                  [resizable]="true">
        <kendo-grid-column field="tpunto" title="Punto" width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tdtm" title="TM" width="115" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tinga" title="Alimentos" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tinga | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tingb" title="Bebidas" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tingb | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tingv" title="Varios" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tingv | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tserv" title="Serv. Paq." width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tserv | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tprop" title="Servicio" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tprop | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tdesc" title="Desctos" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tdesc | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="timpto" title="Impuestos" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.timpto | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="ttotal" title="Total" width="115">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.ttotal | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
      </kendo-grid>
      <div class="row d-flex justify-content-center mt-4">
        <button type="button" class="btn btn-primary px-4 py-3" (click)="close()">Cerrar</button>
      </div>
    </kendo-window>
    <table id="tbl1" border="2" *ngIf="dataGrid.data" style="display: none;">
      <thead>
      <tr>
        <th>Tipo</th>
        <th>Descripcón</th>
        <th>Platillo</th>
        <th>Descripción</th>
        <th>Porción</th>
        <th>Precio</th>
        <th>Ingresos</th>
        <th *ngIf="flagExportExcel">Agencia</th>
        <th *ngIf="flagExportExcel">Segmento</th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let item of dataGrid.data">
        <td>{{ item.ttipo  }}</td>
        <td>{{ item.ttdesc }}</td>
        <td>{{ item.tplat  }}</td>
        <td>{{ item.tdesc  }}</td>
        <td>{{ item.tporc  }}</td>
        <td>{{ item.tprecio }}</td>
        <td>{{ item.tmont | number:'1.2-2' }}</td>
        <td *ngIf="flagExportExcel">{{ item.tagen }}</td>
        <td *ngIf="flagExportExcel">{{ item.tseg }}</td>
      </tr>
      <tr>
        <td></td>
      </tr>
      <tr>
        <td></td>
        <td></td>
        <td></td>
        <td>Total Platillos</td>
        <td>{{ totalPorciones | number:'1.2-2' }}</td>
        <td></td>
        <td>{{ totalImporte | number:'1.2-2' }}</td>
        <td></td>
        <td></td>
      </tr>
      </tbody>
    </table>
  </div>
</div>
